QT += gui dbus

include(../environment.pri)

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets dbus

TEMPLATE = lib
CONFIG += plugin \
          += c++11 \
          link_pkgconfig

PKGCONFIG     += gsettings-qt \
                 kysdk-qtwidgets

LIBS += -lukcc

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS
exists(/etc/apt/ota_version)
{
    DEFINES += DEVICE_IS_INTEL
}

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    bluetooth.cpp \
    bluetoothdbusservice.cpp \
    bluetoothmain.cpp \
    #bluetoothmainwindow.cpp \
    bluetoothnamelabel.cpp \
    devicebase.cpp \
    deviceinfoitem.cpp \
    devremovedialog.cpp \
    devrenamedialog.cpp \
    loadinglabel.cpp \
    ukccbluetoothconfig.cpp

HEADERS += \
    bluetooth.h \
    bluetoothdbusservice.h \
    bluetoothmain.h \
    #bluetoothmainwindow.h \
    bluetoothnamelabel.h \
    config.h \
    devicebase.h \
    deviceinfoitem.h \
    devremovedialog.h \
    devrenamedialog.h \
    loadinglabel.h \
    ukccbluetoothconfig.h

DISTFILES += ukcc-bluetooth.json

TRANSLATIONS += \
    translations/ukcc-bluetooth_zh_CN.ts \
    translations/ukcc-bluetooth_bo_CN.ts

system("lrelease translations/*.ts")

# Default rules for deployment.
unix {
#    target.path = $$[QT_INSTALL_PLUGINS]/generic
    target.path = $$FILES_INSTALL_DIR
}

qm_files.files += translations/*.qm
qm_files.path += $${SHARE_TRANSLATIONS_INSTALL_DIR}

ts_files.files += translations/*.ts
ts_files.path += $${SHARE_TRANSLATIONS_INSTALL_DIR}

INSTALLS += qm_files \
            ts_files \
            target

RESOURCES += \
    ukcc-bluetooth.qrc

