#ifndef CONFIG_H
#define CONFIG_H

#include <QGSettings>
#include <QString>
#include <QByteArray>
#include <QDBusInterface>
#include <QDebug>
#include <QProcess>
#include <QStyle>
#include <QPixmap>

//全局变量，是否是华为机器, 默认false, 在config.cpp文件定义
extern bool global_ishuawei;

class Config : public QObject
{
    Q_OBJECT
public:

    enum PixmapColor {
            WHITE = 0,
            BLACK,
            GRAY,
            BLUE,
    };
    Q_ENUM(PixmapColor)

    Config(QObject *parent = nullptr,QString name = "org.ukui.bluetooth");
    ~Config();

    static void SendNotifyMessage(QString);
    static void OpenBluetoothSettings();
    static bool isHUAWEI();
    static const QPixmap loadSvg(const QPixmap &source, const PixmapColor &color);
private:
    QString setting_name;
    QGSettings    *gsetting = nullptr;
    friend class MainProgram;
    friend class TrayWidget;
};
#endif // CONFIG_H
