#ifndef DEVICESELETERWIDGET_H
#define DEVICESELETERWIDGET_H

#include <KF5/BluezQt/bluezqt/device.h>

#include <QWidget>
#include <QString>
#include <QScrollArea>
#include <QFrame>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QIcon>
#include <QLabel>
#include <QToolButton>
#include <QDebug>
#include <QList>
#include <QPalette>
#include <QColor>
#include <QGSettings>
#include <QScrollBar>
#include <QPainterPath>

#include "./deviceselectitem.h"

#define TRANSPARENCY_SETTINGS       "org.ukui.control-center.personalise"
#define TRANSPARENCY_KEY            "transparency"

class DeviceSeleterWidget : public QWidget
{
    Q_OBJECT
public:
    explicit DeviceSeleterWidget(QMap<QString, QStringList> pairdeviceList, QWidget *parent = nullptr, QString dev = "");
    ~DeviceSeleterWidget();
    void InitUI();
    QString get_seleter_device();
    QString get_seleter_dev_name();
signals:
    void sign_select();
    void unsign_select();

private slots:
    void itemToolbuttonClicked(QStringList device);
    void GSettingsChanges(const QString &key);
private:
    QGSettings *GSettings = nullptr;
    QGSettings *settings  = nullptr;
    QGSettings *transparency_gsettings = nullptr;
    QString select_dev;
    QString select_name;
    bool    isIntel = false;
    double tran =1;

    QList<DeviceSelectItem*> toolbutton_list;
    QLabel      *Tiptop             = nullptr;
    QScrollArea *m_scroll           = nullptr;
    QWidget     *dev_widget         = nullptr;
    QVBoxLayout *device_list_layout = nullptr;
    QMap<QString, QStringList> deviceList;
protected:
    void paintEvent(QPaintEvent *event);
};

#endif // DEVICESELETERWIDGET_H
