#include "mainprogram.h"

#include <QApplication>
#include <QtSingleApplication>
#include <QTranslator>
#include <QLibraryInfo>
#include <QStyleFactory>
#include <QTextCodec>
#include <QDebug>
#include <ukui-log4qt.h>


static QString executeLinuxCmd(QString strCmd)
{
    QProcess p;
    p.start("bash", QStringList() <<"-c" << strCmd);
    p.waitForFinished();
    QString strResult = p.readAllStandardOutput();
    return strResult.toLower();
}

static bool IsHuawei()
{
    QString str = executeLinuxCmd("cat /proc/cpuinfo | grep Hardware");
    if(str.length() == 0)
    {
        return false;
    }

    if(str.indexOf("huawei") != -1 || str.indexOf("pangu") != -1 ||
            str.indexOf("kirin") != -1)
    {
        return true;
    }
    else
    {
        return false;
    }
    return false;
}


int main(int argc, char *argv[])
{
    initUkuiLog4qt("ukui-bluetooth");

    global_ishuawei =  IsHuawei();
    qDebug() << "Ishuawei: "<< global_ishuawei;

    //    QApplication::setStyle(QStyleFactory::create("ukui-default"));
        QApplication::setQuitOnLastWindowClosed(false);
        QApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
        QApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);

    #if (QT_VERSION >= QT_VERSION_CHECK(5, 14, 0))
        QApplication::setHighDpiScaleFactorRoundingPolicy(Qt::HighDpiScaleFactorRoundingPolicy::PassThrough);
    #endif

    QtSingleApplication app(argc, argv);

    if (app.isRunning()) {
        qDebug() << "ukui-bluetooth is Already running ! ! !";
        return EXIT_SUCCESS;
    } else {
        QString locale = QLocale::system().name();
    //        QString locale = "es";
        QTranslator translator;
        if(locale == "zh_CN" || locale == "es" || locale == "fr" || locale == "de" || locale == "ru") {//中文 西班牙语 法语 德语 俄语
            if(!translator.load("ukui-bluetooth_" + locale + ".qm",
                                ":/translations/"))
                qDebug() << "Load translation file："<< "ukui-bluetooth_" + locale + ".qm" << " failed!";
            else
                app.installTranslator(&translator);
        }

        //加载Qt对话框默认的国际化
        QTranslator qtTranslator;
        qtTranslator.load("qt_" + locale,
                          QLibraryInfo::location(QLibraryInfo::TranslationsPath));
        app.installTranslator(&qtTranslator);
        MainProgram *w;
        bool intel = QFile::exists("/etc/apt/ota_version");
        w = new MainProgram(intel);
        if( w->exit_flag ){
            return 0;
        }
        return app.exec();
    }
}
