TARGET = ukui-bluetooth
DESTDIR = .
TEMPLATE = app

include(../qtsingleapplication/qtsingleapplication.pri)
include(../environment.pri)

QT       += core gui dbus KWindowSystem x11extras

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++11 link_pkgconfig USE_OBEX

PKGCONFIG += gsettings-qt \
             kysdk-waylandhelper \
             gio-2.0 \
             kysdk-qtwidgets

# 适配窗口管理器圆角阴影
LIBS +=-lpthread
LIBS +=-lX11 -lXrandr -lXinerama -lXi -lXcursor

LIBS += -L /usr/lib/x86_64-linux-gnu -l KF5BluezQt -lgio-2.0 -lglib-2.0 -lukui-log4qt

QMAKE_LFLAGS += -D_FORTIFY_SOURCE=2 -O2

inst1.files += ../data/org.bluez.Agent1.conf
inst1.path = $$CONF_INSTALL_DIR
inst2.files += ../data/org.ukui.bluetooth.gschema.xml
inst2.path = $$SCHEMAS_INSTALL_DIR
inst3.files += ../data/no-bluetooth.svg
inst3.path = $$SHARE_INSTALL_DIR
inst4.files += ../data/file-transfer-success.svg
inst4.path = $$SHARE_INSTALL_DIR
inst5.files += ../data/file-transfer-failed.svg
inst5.path = $$SHARE_INSTALL_DIR
inst6.files +=../data/connection-failed.svg
inst6.path = $$SHARE_INSTALL_DIR
target.source += $$TARGET
target.path = $$BIN_INSTALL_DIR
INSTALLS += inst1 \
    inst2 \
    inst3 \
    inst4 \
    inst5 \
    inst6 \
    target

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS
#           QT_NO_WARNING_OUTPUT \
#           QT_NO_DEBUG_OUTPUT

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

unix {
    UI_DIR = .ui
    MOC_DIR = .moc
    OBJECTS_DIR = .obj
}

SOURCES += \
    activeConn/activeconnectionwidget.cpp \
    component/bluetoothsettinglabel.cpp \
    component/kyfiledialog.cpp \
    component/qdevitem.cpp \
    component/switchbutton.cpp \
    config/config.cpp \
    fileSend/bluetoothfiletransferwidget.cpp \
    fileReceive/filereceivingpopupwidget.cpp \
    fileSend/deviceselectitem.cpp \
    main/main.cpp \
    main/mainprogram.cpp \
    mainwidget/trayicon.cpp \
    mainwidget/traywidget.cpp \
    pin/pincodewidget.cpp \
    fileSend/deviceseleterwidget.cpp \
    config/xatom-helper.cpp \
    daemon/bluetoothdbus.cpp
HEADERS += \
    activeConn/activeconnectionwidget.h \
    component/bluetoothsettinglabel.h \
    component/kyfiledialog.h \
    component/qdevitem.h \
    component/switchbutton.h \
    config/config.h \
    fileSend/bluetoothfiletransferwidget.h \
    fileSend/deviceselectitem.h \
    fileReceive/filereceivingpopupwidget.h \
    main/mainprogram.h \
    mainwidget/trayicon.h \
    mainwidget/traywidget.h \
    pin/pincodewidget.h \
    fileSend/deviceseleterwidget.h \
    config/xatom-helper.h \
    daemon/bluetoothdbus.h


TRANSLATIONS += \
    translations/ukui-bluetooth_zh_CN.ts \
    translations/ukui-bluetooth_bo_CN.ts
# Default rules for deployment.
#qnx: target.path = /tmp/$${TARGET}/bin
#else: unix:!android: target.path = /opt/$${TARGET}/bin
#!isEmpty(target.path): INSTALLS += target

RESOURCES += \
    ukui-bluetooth.qrc
